// Copyright (c) 2011 Robin Upton <wikipediaPlus [AŦ] RobinUpton [Ð0ŧ] com>
// Last modified: 2011-11-15
//
// N.B. Requires FF6 because of one small patch of code that could pretty easily be circumvented

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 3 of the
// License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA
  
var nsSVG				= "http://www.w3.org/2000/svg";
var nsXSL				= "http://www.w3.org/1999/XSL/Transform";
var nsXUL				= "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
var objPARSER			= new DOMParser();
var objSERIALIZER		= new XMLSerializer();
var objXSLPROC	 		= new XSLTProcessor();

function cloneArray(a)	{ var cA=[]; for (var i=0; i<a.length; i++ ) cA[i]=a[i]; return cA; }
function escape(string) { if (string==null) return ''; else return string.replace("'","\\'"); }
function getIcon() 		{ return document.getElementById("WP-icon"); }
function getStatusBar()	{ return document.getElementById("WP-panel"); }
function getSB() 		{ return document.getElementById("string-bundle"); }
function getMRW() {
	return Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow("navigator:browser");
}

function trimFragment (URLstring)
{ // 2011-11-15		For compatability with FF3-5 which don't have this for NSURI
	var fragIndex= URLstring.indexOf("#"); // Location of first #
	if (fragIndex == -1) return URLstring;
	return URLstring.substring(0, fragIndex);
}

function saveXML(dom, wantSVG)
{ // 2008-11-06		Display DOMs, and remove SVG graphics for easy readability
	return objSERIALIZER.serializeToString(dom, 'text/xml');
	if (dom == null) return null;
	if (isArray(dom)) return 'saveXML(): Bad Call. dom=array!?';
	if (typeof(dom.nodeType) == 'undefined') return 'saveXML(): Bad Call. Bogus dom!';
	if ((typeof(wantSVG)=='undefined') || (!wantSVG)) return objSERIALIZER.serializeToString(dom, 'text/xml');
	// Copy to another DOM
	dom2= document.implementation.createDocument("", "", null);
	if (dom.nodeType== 9) dom=dom.documentElement;
	temp= dom2.importNode(dom, true);
	dom2.appendChild(temp); // not expecting text nodes here
	return (objSERIALIZER.serializeToString(trimDOMbyNS(temp, nsSVG), 'text/xml'));
}

function remotePageExists(URI)
  { 
	var xmlhttp = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"].createInstance();
	xmlhttp.open ('HEAD', URI, false); // Not ascyhronous, so wait
	try 
		{ xmlhttp.send(null); }
	catch (ex)
		{ 
		if (ex.name == "NS_ERROR_FAILURE") 
			{
			//setOffline(); // ???
			return false; 
			}
		else throw(ex); 
		}
	return (xmlhttp.status < 400);
  }

function wikipedify(pageTitle) {
//	var data="";
//	var temp=pageTitle.split(" ");
//	for (var i=0; i<temp.length; i++)
//		data+="_"+temp[i].substring(0,1).toUpperCase()+temp[i].substring(1);
//	return data.substring(1);
	var data=pageTitle.substring(0,1).toUpperCase()+pageTitle.substring(1);	
	return data.replace(" ","_");
}
  
/* function whichButton(e)
{
    var btnCode = e.button;

    switch (btnCode){
      case 0  : alert('Left button clicked');
                break;
      case 1  : alert('Middle button clicked');
                break;
      case 2  : alert('Right button clicked');
                break;
      default : alert('Unexpected code: ' + btnCode);
    }
} */
function hostFromURI(uri) {
	if (!uri.length || uri=="wikipediaPlus-suggestions-notification") return ""; // Catches image and label
	var tempURL= url(uri);
	return tempURL.host;
}

function suggestionExists(notification, uri) {
	var thisDomain= hostFromURI(uri);
	for (temp=notification.firstChild; temp!= null; temp=temp.nextSibling)
		{
		//alert (temp.getAttribute("value")+"\n"+hostFromURI(temp.getAttribute("value"))+"\n"+thisDomain+"\n"+(hostFromURI(temp.getAttribute("value")) == thisDomain));
		if (hostFromURI(temp.getAttribute("value")) == thisDomain) return true;
		}
	return false;
}

function tryAndShow(index, label, icon, uri, accessKey) { //2011-07-10
	var WM=WPMain.WPManager;
	if ((WM.prefs.getBoolPref("wikipediaPlus.check-suggestions"))
		&& (!(WM.isHomeSite(uri)))
		&& (!remotePageExists(uri))) return;
	var nb= getMRW().gBrowser.getNotificationBox();
	if (nb==null) return;
	var notification= nb.currentNotification;
	if (notification == null) 
		{
		var buttons= new Array();
		declineButton = new Object();
		declineButton.label 		= " "+getSB().getString('cancel');
		declineButton.accessKey 	= getSB().getString('cancel.k');
		declineButton.callback		= function() {};
		//declineButton.popup			= "WP-cancel-menu";
		//declineButton.onclick		= "alert(8)";
		if (WM.showCancel) buttons.push (declineButton);
		var message= getSB().getString('notification.'+WM.notificationFormat)+": ";
		nb.appendNotification(message, "wikipediaPlus-suggestions-notification", "chrome://wikipediaPlus/content/images/wikipediaPlus.png", nb.PRIORITY_INFO_HIGH, buttons);
		notification= nb.currentNotification;
		notification.setAttribute('tooltiptext',	getSB().getString('notification.tip'));
		notification.setAttribute('flex',			0);
		notification.setAttribute('onclick',		"if (event.detail >1) WPMain.onShowOptions();");
		if (buttons.length) notification.lastChild.setAttribute('image',			"chrome://wikipediaPlus/content/images/cancel16.png");
		}
	if (suggestionExists(notification, uri)) return; // If a button for this site already exists, stop here.
	var button= document.createElementNS(nsXUL,"button");
	button.setAttribute('value',		uri);
	button.setAttribute('tooltiptext',	uri);
	button.setAttribute('onclick',		"switchSite(this);");
	button.setAttribute('accesskey',	accessKey);
	if ((WM.suggestionFormat>1) ||
		((WM.suggestionFormat==1) && (!icon.length))) button.setAttribute('label',	label);
	if ((!WM.suggestionFormat) && (!icon.length)) icon="chrome://wikipediaPlus/content/images/icon0.png";
	if ((WM.suggestionFormat !=2) && 
		(WM.suggestionFormat !=3)) button.setAttribute('image', 	icon);
	if ((WM.suggestionFormat ==3) ||
		(WM.suggestionFormat ==5)) button.setAttribute('flex',	1);
	if (WM.showCancel 	  !=2)	notification.appendChild(button);
	else notification.insertBefore(button, notification.lastChild);
  }

function switchSite(button) {
	var location=button.getAttribute('value');
	switch (WPMain.WPManager.suggestionLocation)
		{
		case 0:
			Application.activeWindow.activeTab.load(url(location));
			break;
		case 1:
			Application.activeWindow.open(url(location));
			break;
		case 2:
			var newTab= Application.activeWindow.open(url(location));
			newTab.focus();
			break;
		case 3:
			window.open(location, "_new");
		}
};

function url(path) {
	var ioSvc = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService);
	return ioSvc.newURI(path, null, null);
}

function normalise(url) { // Switches the host part of a url into lowercase to simplify matching
	if (url == null || !url.length) return ""; //Prevent exception
	var tempURI= Cc["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService).newURI(url, null, null);
	return tempURI.spec;
}

var WPMain = {
  WPManager: 	null,
  //oldURL: 		null,
  //timerRunning: false,
  onLoad: 		function(event) {
    this.addToAddonBar();
	this.initializeWPManager();
	this.updateIcon();
	this.updateStatusbar();
	this.registerObservers();
  },

  addToAddonBar: function() {
    var addonBar = document.getElementById("addon-bar");
    if (addonBar) 
		{
		if (!document.getElementById("WP-icon"))  addonBar.insertItem("WP-icon");
		if (!document.getElementById("WP-panel")) addonBar.insertItem("WP-panel");
		addonBar.collapsed = false;
		}
  },
  
  registerObservers: function() {
    var observerService = Components.classes["@mozilla.org/observer-service;1"]
    .getService(Components.interfaces.nsIObserverService);
    observerService.addObserver(this, "WP-display", false);
    // Listen for webpage loads
    gBrowser.addProgressListener(myExt_urlBarListener, Components.interfaces.nsIWebProgress.NOTIFY_LOCATION);
  },
 
  getTokenMatch: function(value, template, token) {
	var temp= template.replace(token,"");
    return value.replace(temp,"");
},

  getLangCodeMatch: function(url, template, langlist) {
	var langs=langlist.split(" ");
	for (var i=0; i<langs.length; i++)
		{
		var matchedtemplate=template.replace("{LangCode}", langs[i]).replace("%7BLangCode%7D", langs[i]);
		if (this.WPManager.isMatch2(matchedtemplate, url)) return langs[i];
		}
	this.notifyUnexpectedLanguage();
	//alert (matchedtemplate+"\n"+url+"\n"+this.WPManager.isMatch2(matchedtemplate, url));
    return ("XX"); //Should never happen
},

  handleTemplates: function(newTemplate, thisValue, thisLang, thisTemplate) {
	if (thisLang.split(" ").length>1) 
		thisLang= this.getLangCodeMatch(thisValue, thisTemplate, thisLang);
	if (this.parsedTitle.length) var PageName= this.parsedTitle;
	else var PageName=this.getTokenMatch(thisValue, thisTemplate.replace("%7BLangCode%7D", thisLang).replace("{langcode}", thisLang), "%7BPageName%7D");
//	alert ("LANG="+thisLang+"\n"+"PageName="+PageName+"\nnewTemplate="+newTemplate+"\nRESULT="+newTemplate.replace("%7BPageName%7D", PageName).replace("%7BLangCode%7D", thisLang).replace("{langcode}", thisLang));
	//%7BPageName%7D and {PageName} depend on the position of the "{PageName}" section in the URI
	if (!this.WPManager.blockedPageName(PageName)) return newTemplate.replace("%7BPageName%7D", PageName).replace("{PageName}", PageName).replace("%7BLangCode%7D", thisLang).replace("{langcode}", thisLang);
},

  initializeWPManager: function() { this.WPManager = Components.classes['@robinupton.com/WPmanager;1'].getService().wrappedJSObject; },
  
  checkAlternatives: function(document) {
  	if (!(document instanceof HTMLDocument) || (this.WPManager == null) || !(this.WPManager.isEnabled()) || (document.location == "about:blank")) return;
  	var siteId= this.WPManager.getThisSiteID(document.location+"");
    if (typeof(siteId)=="undefined") return;
	var	possibleOptions= cloneArray(this.WPManager.siteArray);
	if (this.WPManager.showPreferredOnly) possibleOptions.splice(siteId);
	else possibleOptions.splice(siteId, 1);
    this.parseTitle();
    this.showSiteSuggestions(this.WPManager.siteArray[siteId], possibleOptions);
  },
  
  parseTitle: function() {
	this.parsedTitle="";
	switch (WPMain.WPManager.prefs.getIntPref("wikipediaPlus.suggestion-method"))
		{// Method >0: Handle redirects
		case 1:
			var titleh1= Application.activeWindow.activeTab.document.getElementById("firstHeading");
			if (titleh1!= null) this.parsedTitle= wikipedify(titleh1.textContent);
		default:
		}
	},
  
  URLequalsExceptRef: function(URL1, URL2) { // Are they are on the same page?
	var URLtemp1= URL1.prePath + URL1.path;
	var URLtemp2= URL2.prePath + URL2.path;
	return (trimFragment(URLtemp1) == trimFragment(URLtemp2));
  },
  
  onContentLoad: function(event) { // When a page finishes loading
	if (this.WPManager.searchAfter) 
		if (event.DOMTitleChanged) // 0.7.2 Stop internal links firing 
			this.checkAlternatives(event.originalTarget);
  },

  onUnload: function() { //tidy up
	 gBrowser.removeProgressListener(myExt_urlBarListener);
  },

  hideNotificationBar:function() {
	getMRW().gBrowser.getNotificationBox().removeAllNotifications(false);
  },
  
  onBlockPagename: function() { alert ("Block Pagename"); },
  onBlockUrl: function() { alert ("Block Url"); },
  
  onShowOptions: function(event) {
	if (event.button != 0) return;
	window.openDialog('chrome://wikipediaPlus/content/options.xul', 'dialog', 'modal,resizable,scrollbars,status,chrome');
  },

  onToggleEnabled: function(event) {
	if (event.button != 0) return;
    this.toggleEnabled();
	this.updateStatusbar();
  },
  
  processNewURL: function() {
	if (this.WPManager.searchWhile) 
		{
		var heredoc=getMRW().gBrowser.contentDocument;
		this.checkAlternatives(heredoc);
		}
  },
  
  setDisabledStatus: function() {
    if (this.WPManager.isShortStatus()) 
      this.setWPPanel('shortDisabled', 'longDisabled', "red", 0);
    else
      this.setWPPanel('longDisabled', 'longDisabled', "red", 0);
    this.setStatusContext('enable');
    this.hideNotificationBar();
  },

  setEnabledStatus: function() {
    if (this.WPManager.isShortStatus()) 
      this.setWPPanel('shortEnabled', 'longEnabled', "green", 1);
    else
      this.setWPPanel('longEnabled', 'longEnabled', "green", 1);
    this.setStatusContext('disable');
	this.checkAlternatives(getMRW().gBrowser.contentDocument);
  },
  
  setStatusContext:function (name) {
    document.getElementById("WP-status-context1").label = this.localisedString(name);
    document.getElementById("WP-status-context2").label = this.localisedString(name);
    document.getElementById("WP-status-context3").label = this.localisedString(name);
  },
  
  setWPPanel: function (text, tooltip, color, enabled) {
      var panel = document.getElementById("WP-panel");
	  panel.setAttribute("style", "color: "+color+";");
	  panel.setAttribute("tooltiptext", this.localisedString(tooltip));
	  if (panel.textContent) panel.textContent = this.localisedString(text);
	  else panel.label = this.localisedString(text);
	  var icon = document.getElementById("WP-icon");
	  icon.src="chrome://wikipediaPlus/content/images/wp24"+enabled+".png";
  },
  
  showSiteSuggestions: function(currentSite, siteArray) {
	var thisurl=Application.activeWindow.activeTab.uri.spec;
	var thislang= this.getLangCodeMatch(thisurl, currentSite.getAttribute("url"), currentSite.getAttribute("lang"));
	for (var i=0; i<siteArray.length; i++)
		{ //Try and show site
		var site= siteArray[i];
		if ((this.WPManager.sameLanguage) && (site.getAttribute("lang").indexOf(thislang) == -1)) continue;
		var uri = this.handleTemplates(normalise(site.getAttribute("url")), thisurl, currentSite.getAttribute("lang"), normalise(currentSite.getAttribute("url")));
		if (typeof(uri)!="undefined") 
			setTimeout("tryAndShow('"+i+"','"+escape(site.getAttribute('name'))+"','"+escape(normalise(site.getAttribute('icon')))+"','"+escape(uri)+"','"+escape(site.getAttribute('key'))+"')", 1);
		}
  },
 
  localisedString:function(name) {
	var SB= document.getElementById("string-bundle");
	return SB.getString(name);
  },
  
  notifyUnexpectedLanguage: function() {
	//	this.WPManager.displayNotification("Unxpected Language!","Your WikipediaPlus sitelist is missing this language. Please update it accordingly.");
  },
 
  observe: function(subject, topic, data) {
    switch (topic)
		{
		case "WP-display":
			this.updateIcon();
			this.updateStatusbar();
		}
  },
  
  toggleEnabled: function() {
	this.WPManager.setEnabled(!this.WPManager.isEnabled());
  },

  updateIcon: function() {
	getIcon().collapsed= !this.WPManager.showIcon;
  },

  updateStatusbar: function() {
	getStatusBar().collapsed= (this.WPManager.statusbarFormat<1);
	(this.WPManager.isEnabled() ? this.setEnabledStatus() : this.setDisabledStatus());
  }
  
};

var myExt_urlBarListener = {
  QueryInterface: function(aIID)
  {
   if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
       aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
       aIID.equals(Components.interfaces.nsISupports))
     return this;
   throw Components.results.NS_NOINTERFACE;
  },
  
  onLocationChange: function(aBrowser, webProgress, aRequest, aURI) 
  { 
	var history =aBrowser.sessionHistory;
	var last = history.getEntryAtIndex(history.count-1, false).URI;
//	alert (prelast.path+ prelast.prePath);
//	alert (last.path+last.prePath);
//	alert (last);
	var prelast = history.getEntryAtIndex(history.count-2, false).URI;
//	alert (prelast);
	if (!WPMain.URLequalsExceptRef(last, prelast)) 
		WPMain.processNewURL(); 
  },
  onStateChange: function(a, b, c, d) {},
  onProgressChange: function(aBrowser, webProgress, request, curSelfProgress, maxSelfProgress, curTotalProgress, maxTotalProgress) 
  { // Check we have enough to work out the real title, then look up...
  // Improve responsiveness here for 0.9
  },
  onStatusChange: function(a, b, c, d) {},
  onSecurityChange: function(a, b, c) {}
};

window.addEventListener("load", function(e)  { WPMain.onLoad(e);  }, false); 
window.addEventListener("unload", function() { WPMain.onUnload(); }, false);
window.document.addEventListener("DOMContentLoaded", function(e) {WPMain.onContentLoad(e);}, true);
