// Copyright (c) 2011 Robin Upton <robin [At] wikipedia plus [d0t] org>
// Last modified: 2011-07-12

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 3 of the
// License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA

function getSB() 				{ return document.getElementById("string-bundle"); }
function getSingleLanguageMenu() { return document.getElementById("site-langs-single"); }
function getMultiLanguageText()	{ return document.getElementById("site-langs-multi"); }
function getURLText()  			{ return document.getElementById("site-url"); }
function getLanguages() {
	if (document.getElementById("site-ml").selectedIndex) 
		return getMultiLanguageText().value;
	else
		return getSingleLanguageMenu().value.substring(0,2);
}

function deselectLanguages() {
	getSingleLanguageMenu().selectedIndex=-1;
	//deselectElements("richlistitem");
}

function deselectElements(tagName) {
	var temp=document.getElementsByTagName(tagName);
	for (i=0;i<temp.length;i++) temp[i].selected=false;
}

function setMultiLanguage(status) {
	document.getElementById("site-ml").selectedIndex= status;
	document.getElementById("site-langs-multi").disabled= !status;
	getSingleLanguageMenu().disabled= status;
}

function setUrl(status) {
	setUrlItems("site-url-simple", 1-status);
	setUrlItems("site-url-advanced", status);
}

function setUrlItems(ID, status) {
	var temp=childElements(document.getElementById(ID).parentNode);
	for (i=0;i<temp.length;i++)	i.disabled= !status;
	//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
}

function setLanguage(languageCode) {
	getSingleLanguageMenu().selectedIndex= getSingleLanguageMenu().getIndexOfItem(document.getElementById(languageCode+"1"));
}

function setLanguages(languageCodeList) {
	if (typeof(languageCodeList)=="null") return;
    document.getElementById("site-langs-multi").value=languageCodeList;
	var temp = languageCodeList.split(' ');
	setMultiLanguage(0+(temp.length>1));
	deselectLanguages();
    for (i=temp.length;i>0;) setLanguage(temp[--i]);
}

function setTitle(newTitle) {
	document.getElementById("WP-add-edit-site").setAttribute("title", newTitle);
}

function onDialogLoad() {
  var retVal = window.arguments[0];
  if (retVal.site.hasAttribute('name'))
	{
	var site=retVal.site;
    setTitle(getSB().getString('Editing')+" "+site.getAttribute("name"));
    document.getElementById("site-name").value =	site.getAttribute("name");
    document.getElementById("site-icon").value = 	site.getAttribute("icon");
    onSiteIconTest();
    document.getElementById("site-url").value = 	site.getAttribute("url");
    setLanguages(site.getAttribute("lang"));
    document.getElementById("site-key").value  =	site.getAttribute("key");
    } 
  else 
	{
	setTitle(getSB().getString('Adding'));
	setLanguages(getSB().getString('DefaultLanguage'));
	}
}

function onDialogOK() {  
  var icon              = document.getElementById("site-icon").value;
  var name              = document.getElementById("site-name").value;
  var url               = document.getElementById("site-url").value;
  var lang	 			= getLanguages();
  var key	            = document.getElementById("site-key").value.substring(0,1);
  if (!name) 																return myError('ErrorNoName');
  if (!url) 																return myError('ErrorNoURL');
  if (url.indexOf("{PageName}") == -1) 										return myError('ErrorNoPageName');
  if ((lang.split(" ").length > 1) && (url.indexOf("{LangCode}") == -1)) 	return myError('ErrorNoLangCode');
  var retVal = window.arguments[0];
  retVal.site.setAttribute("icon", 	 icon);
  retVal.site.setAttribute("lang", 	 lang);
  retVal.site.setAttribute("name",	 name);
  retVal.site.setAttribute("url", 	 url);
  retVal.site.setAttribute("key", 	 key);
//  alert (saveXML(retVal.site));
  retVal.OK= true;
  return true;
}

function myError(message) { alert (getSB().getString(message)); return false; }
function onMultiLanguageSelect(newvalue) { setMultiLanguage(0+newvalue); }

function onIconInput(textbox) {
	//alert (this.value); //@@@
}

function onSiteIconTest() {
   document.getElementById("site-icon-preview").src= document.getElementById("site-icon").value;
}

function onSiteUseCurrent() { // Possibility to add voodoo here
	var temp=Application.activeWindow.activeTab.uri.spec
	if (temp.substring(temp.length-1,temp.length)=="/") temp=temp.substring(0,temp.length-1);
	var temp=temp.split("/");
	var tempURI="";
	if (temp.length==3) tempURI=Application.activeWindow.activeTab.uri.spec;
	else for (var i=0; i<limit; i++) tempURI+=temp[i]+"/";
	getURLText().value= tempURI+"{PageName}";
}

function onUrlSelect(newvalue) { setUrl(0+newvalue); }
