// Copyright (c) 2011 Robin Upton <robin [At] robin upton [d0t] com>
// Last modified: 2011-06-01

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 3 of the
// License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA

var nsSVG				= "http://www.w3.org/2000/svg";
var nsXSL				= "http://www.w3.org/1999/XSL/Transform";
var objPARSER			= new DOMParser();
var objSERIALIZER		= new XMLSerializer();
var objXSLPROC	 		= new XSLTProcessor();

function isElement(domNode, localname, nsuri)
{ // 2008-10-20		Check for particular elements
	if (domNode == null) alert("isElement(): NULL node");
	else return ((domNode.namespaceURI==nsuri) && (domNode.localName==localname));
}

function appendFragment(DOMelement, DOMfragment)
{ // 2011-05-31  - DOMfragment is a different DOM from DOMelement
	var nexttemp;
	var temp= DOMfragment.firstChild;
	while (temp!= null) 
		{ //Add all children in before
		nexttemp=temp.nextSibling;
		DOMelement.appendChild(DOMelement.ownerDocument.importNode(temp,1));
		temp=nexttemp;
		}
}

function childElements(DOMNode)
{ // 2011-06-01
	var kids=[];
	var count=0;
	var temp=DOMNode.firstChild;
	while (temp!= null) 
		{
		if (temp.nodeType==1) kids[count++]=temp;
		temp=temp.nextSibling;
		}
	return kids;
}

function removeChildNodes(DOMelement)
{ // 2008-08-11
	while (DOMelement.firstChild != null) DOMelement.removeChild(DOMelement.firstChild);
}

function saveXML(dom, wantSVG)
{ // 2008-11-06		Display DOMs, and remove SVG graphics for easy readability
	return objSERIALIZER.serializeToString(dom, 'text/xml');
	if (dom == null) return null;
	if (isArray(dom)) return 'saveXML(): Bad Call. dom=array!?';
	if (typeof(dom.nodeType) == 'undefined') return 'saveXML(): Bad Call. Bogus dom!';
	if ((typeof(wantSVG)=='undefined') || (!wantSVG)) return objSERIALIZER.serializeToString(dom, 'text/xml');
	// Copy to another DOM
	dom2= document.implementation.createDocument("", "", null);
	if (dom.nodeType== 9) dom=dom.documentElement;
	temp= dom2.importNode(dom, true);
	dom2.appendChild(temp); // not expecting text nodes here
	return (objSERIALIZER.serializeToString(trimDOMbyNS(temp, nsSVG), 'text/xml'));
}

function trimDOMbyNS(domNode, uri)	// Used to remove SVG graphics
{ // 2008-09-27		Removes all the nodes (and all descendants) from a DOM, 
	nodesToTrim = domNode.ownerDocument.evaluate('.//*[namespace-uri()="'+uri+'"]', domNode, null, XPathResult.ANY_TYPE, null);
	trimArray= xPathIteratorToArray (nodesToTrim);
	for (var i = 0; i < trimArray.length; i++) zap(trimArray[i]);
	return domNode;
}

function transformToFragment(dom, stylesheet, params)
{ // 2011-06-06		Safer than transformToDocument
	//alert(saveXML(dom)+"\n########################\n"+saveXML(stylesheet));
	var error=0;
	try
		{
		if (!isElement(stylesheet.documentElement, 'stylesheet', nsXSL))
			{
			alert('Bogus transform (Rootnode='+stylesheet.documentElement.tagName+')');
			error=1;
			}
		}
	catch (ex)
		{ // bad XML, or an <xsl:include> problem.)'); ???
		alert ('Bogus Stylesheet!\n\n'+ex.message);
		error=1;
		}
	if (error==0) 
		{
		try
			{ // This may throw exceptions, which get caught below
			objXSLPROC.importStylesheet(stylesheet);
			}
		catch (ex)
			{ // <xsl:include> or <xsl:import> problem.
			// alert ('XSL include/import problem.\n- Have you checked the fuse?');
			// return;
			// DUNNO WHY IT THROWS EXCEPTIONS HERE, IGNORE FOR NOW
			}
		if (typeof(params)=='object') for (var i = 0; i < params.length; i=i+3) objXSLPROC.setParameter(params[i], params[i+1], params[i+2]);
		try
			{ // This may throw exceptions, which get caught below
			return objXSLPROC.transformToFragment(dom, document);
			}
		catch (ex)
			{ alert ('XSL Transform problem: '+ex.message); }
		}
}

