<?xml version="1.0" encoding="UTF-8"?>
<!-- Last modified: 2011-06-13
wpsl2xul-tree-0.xsl		-		Presentation of a sitelist as nested tree

Create a nested XUL treeview out of a <WP:list> file.
-->
<xsl:stylesheet version="1.0" xmlns="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul" xmlns:WP="http://RobinUpton.com/WP/" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:template match="/WP:list">
	<window>
		<tree id="siteListTree" align="stretch" flex="1" hidecolumnpicker="false" enableColumnDrag="true" editable="true" onselect="onSiteListTreeSelect();" onkeypress="onSiteListTreeSelect();" seltype="single" treelines="true">
			<treecols style="background-color: #FFFFCC; border: 4px solid green">
				<treecol id="enabled" type="checkbox" flex="1" label="Enabled" cycler="true" editable="true" hidden="true"/>
				<treecol id="editor" type="checkbox" flex="1" label="Editor" cycler="true" editable="true" hidden="true"/>
				<treecol id="name" flex="4" label="Name" editable="false" primary="true"/>
				<treecol id="lang" flex="3" label="Languages" editable="false" hidden="true"/>
				<treecol id="URL" flex="10" label="URL" editable="false"/>
				<treecol id="key" flex="1" label="Key" editable="false" hidden="true"/>
			</treecols>
			<treechildren flex="1">
				<xsl:apply-templates/>
			</treechildren>
		</tree>
		</window>
	</xsl:template>
	<xsl:template match="WP:site">
		<treeitem>
			<treerow>
				<xsl:variable name="iconURL">
					<xsl:value-of select="@icon"/>
					<xsl:if test="not(@icon)">chrome://wikipediaPlus/content/images/site.png</xsl:if>
				</xsl:variable>
				<treecell id="enabled" fixed="true" label="{not(@enabled=0)}" editable="true"/>
				<treecell id="editor" fixed="true" label="{not(@enabled=0)}" editable="true"/>
				<treecell id="name" iconURL="{$iconURL}" label=" {@name}" editable="false"/>
				<treecell id="lang" label="{@lang}" editable="false"/>
				<treecell id="URL" label="{@url}" editable="false"/>
				<treecell id="key" label="{@key}" editable="false"/>
			</treerow>
		</treeitem>
	</xsl:template>
	<xsl:template match="WP:list">
		<treeitem container="true" open="true">
			<treerow>
				<xsl:variable name="icon">
					<xsl:value-of select="@icon"/>
					<xsl:if test="not(@icon)">chrome://wikipediaPlus/content/images/list.png</xsl:if>
				</xsl:variable>
				<xsl:variable name="name">
					<xsl:value-of select="@name"/>
					<xsl:if test="not(@name)">(LIST)</xsl:if>
				</xsl:variable>
				<treecell id="enabled" fixed="true" width="70" value="{not(@enabled=0)}" editable="true"/>
				<treecell id="name" src="{$icon}" label=" {$name}" editable="false"/>
				<treecell id="URL" label="{@url}" editable="false"/>
			</treerow>
			<xsl:if test="count(*)">
				<treechildren flex="1">
					<xsl:apply-templates/>
				</treechildren>
			</xsl:if>
		</treeitem>
	</xsl:template>
</xsl:stylesheet>
