// Copyright (c) 2011 Robin Upton <wikipediaPlus [áŧ] RobinUpton [Ð0ŧ] com>
// Last modified: 2011-11-11

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 3 of the
// License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA

Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");

const nsWP= 			"http://RobinUpton.com/WP/";
const EXTENSION_ID= 	"wikipediaPlus@RobinUpton.com";
const fnCONTENT= 		"chrome/content/";
var fnDEFAULTSITELIST= 	fnCONTENT+"sites-default.xml";
var fnPAGELIST= 		fnCONTENT+"pages.xml";
var fnSITELIST= 		fnCONTENT+"sites.xml";
var objPARSER= 			Components.classes["@mozilla.org/xmlextras/domparser;1"].createInstance(Components.interfaces.nsIDOMParser);

function HTMLCollectionToArray(hc) { var a= new Array(); for (var i=0;i<hc.length;i++) a[i]=hc.item(i); return a;	}
	  
function WPManager() {   
	this.wrappedJSObject = this;
	this.initializeExtensionVersion();
	this.initializePageList();
	this.initializeSiteList();
	this.stylesheets= new Array();
	for (var i=0; i<2; i++)	//this.stylesheets[i]=this.loadXMLFile(this.getFile(fnCONTENT+"wpsl2xul-"+i+".xsl"));
		this.stylesheets[i]=this.loadXMLContent("wpsl2xul-"+i+".xsl");
	this.initializePrefs();
//	this.registerHeadersObserver();
}

WPManager.prototype = {
	classDescription:	"WikipediaPlusManager Component",
	classID:			Components.ID("{89855011-3903-beef-bd98-c01715087602}"),
	contractID:			"@robinupton.com/WPmanager;1",
	QueryInterface: 	XPCOMUtils.generateQI(),
	extensionVersion: 	"0.0",
	enabled: 			false,
	pageListChanged: 	false,
	siteListChanged: 	false,
	changePageList:		function()	 	{ this.pageListChanged=true; },
	changeSiteList: 	function()	 	{ this.siteListChanged=true; },
	getPageArray: 		function() 		{ return this.pageArray; },
	getPageList: 		function() 		{ return this.pageList; },
	getSiteList: 		function() 		{ return this.siteList; },
	setPageList: 		function(DOM) 	{ this.pageList= DOM; this.changePageList(); this.pageArray= HTMLCollectionToArray(DOM.getElementsByTagName("page")); },
	setSiteList:		function(DOM) 	{ this.siteList= DOM; this.changeSiteList(); this.siteArray= HTMLCollectionToArray(DOM.getElementsByTagName("site")); },
	getStylesheet:		function(i)		{ return this.stylesheets[i]; },
	getThisSiteID:		function(URL) 	{ 
		for (var i=0; i<this.siteArray.length; i++)
			if (this.isMatch(this.siteArray[i].getAttribute("url"), URL)) return i; },
	getThisSiteEntry: function(URL) { 
		var id=this.getThisSiteID(URL);
		if (typeof(id)!="undefined") return this.siteArray[id]; },
	isEnabled:			function() 		{ return this.enabled; },
	isShortStatus:		function() 		{ return this.statusbarFormat==1; },
	setEnabled:			function(value) { this.enabled = value; },
//    updateSiteList: function() {
	// Checks all the site lists are up to date
//	},
	
	// NOTIFICATION Code
	displayNotification: function(title, message) {
		try {
			  var alertsService = Components.classes["@mozilla.org/alerts-service;1"]  
			  .getService(Components.interfaces.nsIAlertsService);  
			  alertsService.showAlertNotification ("chrome://wikipediaPlus/content/images/wp64.png", title, message, false, "", null, "");  
			} 
		catch (e) { this.notify(title, message); }
	},
	notify : function(title, message) {
		var serializer = Components.classes["@mozilla.org/xmlextras/xmlserializer;1"].createInstance(Components.interfaces.nsIDOMSerializer);
		try { title=  "XML: "+serializer.serializeToString(title,   'text/xml'); } catch (e) { }
		try { message="XML: "+serializer.serializeToString(message, 'text/xml'); } catch (e) { }
		var window = Components.classes['@mozilla.org/embedcomp/window-watcher;1'].getService(Components.interfaces.nsIWindowWatcher).openWindow(null, 'chrome://global/content/alerts/alert.xul', '_blank', 'chrome,titlebar=no,popup=yes',null);
		window.arguments = [null, title, message, false, ''];
	},
	updateLocalStatus: function() { },
	//@@@ BELOW = voodoo to go
	observe: function(subject, topic, data) {
		if (topic == 'http-on-modify-request' || topic == 'http-on-examine-response') 
			{
			if (!this.enabled) return;
			subject.QueryInterface(Components.interfaces.nsIHttpChannel);
			}
	  },
    
    // FILE I/O Code - Could do with a clean.
	getFile: function(path) { // Gets a file in Profile Directory
	    if ("@mozilla.org/extensions/manager;1" in Components.classes) 
			{ //FF3
			var extensionManager = Components.classes["@mozilla.org/extensions/manager;1"].
			getService(Components.interfaces.nsIExtensionManager);
			var file = extensionManager.getInstallLocation(EXTENSION_ID).location;
			} 
		else 
			{ //FF4 (MAYBE ALSO FF3, NOT SURE)
			 var directoryService = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties);
			 var file = directoryService.get("ProfD", Components.interfaces.nsIFile);
			file.append("extensions");
			}
		file.append(EXTENSION_ID);
		var temp = path.split("/");
		for (var i=0; i<temp.length; file.append(temp[i++])) {};
		return file;
	},
/*	getInputStream: function(file) {
		return Components.classes["@mozilla.org/network/file-input-stream;1"]
  .createInstance(Components.interfaces.nsIFileInputStream);
  inputStream.init(file, -1, -1, Components.interfaces.nsIFileInputStream.CLOSE_ON_EOF);
	},*/
	getOutputStream: function(path) {
		var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
		file= this.getFile(path);
		try {
			outputStream.init(file, 0x02 | 0x08 | 0x20, 0664, 0);
			}
		catch (e)
			{
			this.displayNotification ("WP+ ERROR: getOutputStream() fail. "+e.message, "Disk full??");
			}
//		this.notify(path+("@mozilla.org/extensions/manager;1" in Components.classes), outputStream);
		return outputStream;
	},
	loadXMLContent: function(sheetName) {
		var xmlhttp = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"].createInstance();
		xmlhttp.open ('GET', "chrome://wikipediaPlus/content/"+sheetName, false); // Not ascyhronous, so wait
		xmlhttp.send(null);
		return xmlhttp.responseXML;
	},
	loadXMLFile: function(file) {
		if (!file.exists()) return null;
		var data = "";
		var fstream = Components.classes["@mozilla.org/network/file-input-stream;1"].
				  createInstance(Components.interfaces.nsIFileInputStream);
		var cstream = Components.classes["@mozilla.org/intl/converter-input-stream;1"].
				  createInstance(Components.interfaces.nsIConverterInputStream);
		fstream.init(file, -1, 0, 0);
		cstream.init(fstream, "UTF-8", 0, 0);
		let (str = {}) 
			{
			let read= 0;
			do
				{ 
				read = cstream.readString(0xffffffff, str); // Read as much as we can and put it in str.value
				data += str.value;
				} 
			while (read != 0);
			}
		cstream.close(); // this closes fstream
		var object= objPARSER.parseFromString(data, "text/xml");
		if ((object== null) || (object.documentElement.tagName =="parsererror"))
			{
			this.displayNotification ("WP+ ERROR: loadFromFile() found BAD XML:", data);
			return null;
			}
		return object;
	},
	serializeToFile: function (DOM, path) {
		var serializer   = Components.classes["@mozilla.org/xmlextras/xmlserializer;1"].createInstance(Components.interfaces.nsIDOMSerializer);
		serializer.serializeToStream(DOM, this.getOutputStream(path), "UTF-8");
	},

	// INITIALIZATION CODE
	initializePrefs:function() {
		try
			{
			this.prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.");
			this.enabled=			this.prefs.getBoolPref("wikipediaPlus.enabled");
			this.maxConnections= 	this.prefs.getIntPref("wikipediaPlus.max-connections");
			this.maxSuggestions= 	this.prefs.getIntPref("wikipediaPlus.max-suggestions");
			this.notificationFormat=this.prefs.getIntPref("wikipediaPlus.notification-format");
			this.optionsTopTab=  	this.prefs.getIntPref("wikipediaPlus.options-top-tab");
			this.sameLanguage=		this.prefs.getBoolPref("wikipediaPlus.same-language");
			this.searchAfter=		this.prefs.getBoolPref("wikipediaPlus.search-after");
			this.searchWhile=		this.prefs.getBoolPref("wikipediaPlus.search-while");
			this.showCancel=		this.prefs.getIntPref("wikipediaPlus.show-cancel");
			this.showIcon=			this.prefs.getBoolPref("wikipediaPlus.show-icon");
			this.showPreferredOnly=	this.prefs.getBoolPref("wikipediaPlus.show-preferred-only");
			this.statusbarFormat=	this.prefs.getIntPref("wikipediaPlus.statusbar-format");
			this.suggestionFormat=	this.prefs.getIntPref("wikipediaPlus.suggestion-format");
			this.suggestionLocation=this.prefs.getIntPref("wikipediaPlus.suggestion-location");
			}		
		catch (e) { this.notify("Failure to set up preferences ["+e.message+"]", "Check 'default.js' ..."); }
	},
	initializeSiteList: function() {
//		this.notify(this.siteList); @@@@ ABOVE FAILS SILENTLY BUT FATALLY IF NO FILE THERE
// SHOULD JUST LOAD FROM default-sites.xml file
//		if (this.siteList==null) 
//			this.siteList= this.loadXMLContent("sites-default.xml");
		this.setSiteList(this.loadXMLContent("sites.xml"));
	},
	initializePageList: function() { 
		this.setPageList(this.loadXMLContent("pages.xml"));
	},
	initializeExtensionVersion: function() {
		if ("@mozilla.org/extensions/manager;1" in Components.classes) 
			{ // FF.3
			var gExtensionManager = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
			this.extensionVersion = gExtensionManager.getItemForID(EXTENSION_ID).version;
			} 
		else 
			{ // FF.4/5
			Components.utils.import("resource://gre/modules/AddonManager.jsm");
			var self = this;
			AddonManager.getAddonByID(EXTENSION_ID, function(addon) 
				{ self.extensionVersion = addon.version; });
			}
	},

	update: function() { //Save state
		this.prefs.setBoolPref("wikipediaPlus.enabled",  			this.enabled);
		this.prefs.setIntPref("wikipediaPlus.max-connections",  	this.maxConnections);
		this.prefs.setIntPref("wikipediaPlus.max-suggestions",  	this.maxSuggestions);
		this.prefs.setIntPref("wikipediaPlus.notification-format",	this.notificationFormat);
		this.prefs.setIntPref("wikipediaPlus.options-top-tab",  	this.optionsTopTab);
		this.prefs.setBoolPref("wikipediaPlus.same-language",   	eval(this.sameLanguage));
		this.prefs.setBoolPref("wikipediaPlus.search-after",    	eval(this.searchAfter));
		this.prefs.setBoolPref("wikipediaPlus.search-while",    	this.searchWhile);
		this.prefs.setIntPref("wikipediaPlus.show-cancel",    		this.showCancel);
		this.prefs.setBoolPref("wikipediaPlus.show-icon",    		this.showIcon);
		this.prefs.setBoolPref("wikipediaPlus.show-preferred-only",	this.showPreferredOnly);
		this.prefs.setIntPref("wikipediaPlus.statusbar-format",    	this.statusbarFormat);
		this.prefs.setIntPref("wikipediaPlus.suggestion-format",	this.suggestionFormat);
		this.prefs.setIntPref("wikipediaPlus.suggestion-location",	this.suggestionLocation);
		//if (this.pagelistChanged) 
		this.serializeToFile(this.pageList,  fnPAGELIST);
		this.pagelistChanged=false;
		//if (this.siteListChanged) 
		this.serializeToFile(this.siteList,  fnSITELIST);
		this.siteListChanged=false;
		//this.notify('WM save');
		var observerService = Components.classes["@mozilla.org/observer-service;1"]
    .getService(Components.interfaces.nsIObserverService);  
    observerService.notifyObservers(observerService, "WP-display", false);
		return;
	},
  
/*  registerHeadersObserver: function() {
    var observerService = Components.classes["@mozilla.org/observer-service;1"]
    .getService(Components.interfaces.nsIObserverService);
    observerService.addObserver(this, "http-on-modify-request", false);
    observerService.addObserver(this, "http-on-examine-response", false);
    observerService.addObserver(this, "network:offline-status-changed", false);
  },*/

	// MATCHING LOGIC 	
	addPage: function (pageName) {
		var newPage= this.pageList.createElementNS(nsWP,"page");
		newPage.setAttribute("name",pageName);
		this.pageList.documentElement.appendChild(newPage);
		this.setPageList(this.pageList); //messy
	},
	blockedPageName: function(pageName) {
		for (var i=0; i<this.pageArray.length; i++) 
			{// Not a RegExp. Only wildcardery is '*' on the end to match any characters
			var name=this.pageArray[i].getAttribute('name');
			if (pageName==name) return true;
			if ((name.substr(-1,1)=="*") && (pageName.indexOf(name.substring(0,name.length-1))>-1)) return true;
			}
		return false;
	},
	isHomeSite: function(url) {
		if (!this.prefs.getCharPref("wikipediaPlus.home-site").length) return false
		return this.isMatch2(this.prefs.getCharPref("wikipediaPlus.home-site"), url);
	},
	isMatch: function(template, url) {
		var siteRegexp=new RegExp(template.replace("{PageName}",".+").replace("{LangCode}","[a-z][a-z]"), 'i'); // Case insensitive
		//this.notify(siteRegexp, url+' => '+url.match(siteRegexp));
		return url.match(siteRegexp);
	},
	isMatch2: function(template, url) {
		var siteRegexp=new RegExp(template.replace("{PageName}",".+").replace("%7BPageName%7D",".+").replace("{LangCode}","[a-z][a-z]").replace("{langcode}","[a-z][a-z]").replace("%7BLangCode%7D","[a-z][a-z]"), 'i'); // Case insensitive
		//this.notify(siteRegexp, url+' => '+url.match(siteRegexp));
		return url.match(siteRegexp);
	}
};

var components = [WPManager];
if (XPCOMUtils.generateNSGetFactory) var NSGetFactory = XPCOMUtils.generateNSGetFactory(components);
else var NSGetModule = XPCOMUtils.generateNSGetModule(components);
